/*
 * (c) 2003, Victoria Staubly (vicky@steeds.com), GPL
 */
#include <stdio.h>
#include <stdlib.h>
#include "proto.h"

int main(int argc, char **argv)
{
    int i, rc;
    int verbose = 0;
    int delete = 1;
    char *queryString;

    if ((rc = initAPI()) != 0)
	return rc;

    queryString = getenv("QUERY_STRING");
    if (queryString != NULL) {
	/* parsing form input goes here */
	/* example: /cgi-bin/popflush?popserver=suffolk.steeds.com&popusername=benson&poppasswd=&cmd=delete&Submit+Form= */
	char *host = extractCgiParm("popserver",queryString);
	char *user = extractCgiParm("popusername",queryString);
	char *pass = extractCgiParm("poppasswd",queryString);
	char *cmd  = extractCgiParm("cmd",queryString);
	char *verb = extractCgiParm("verbose",queryString);

	verbose = (verb == NULL) ? 0 : (strcmp(verb,"on") == 0);
	delete = (strcmp(cmd,"delete") == 0);

        printf("Content-Type: text/plain\n\n");

	pop3session(host,user,pass,verbose,delete,stdout);

	cgiFree(host);
	cgiFree(user);
	cgiFree(pass);
	cgiFree(cmd);
	cgiFree(verb);
    } else {
	if (argc < 4) {
	    fprintf(stderr,"usage: %s server username password\n",argv[0]);
	    return(1);
	}
	for (i = 1; (i < argc) && (argv[i][0] == '-'); i++) {
	    if (argv[i][1] == 'v')
		verbose = 1;
	    else if (argv[i][1] == 's')
		delete = 0;
	}

	pop3session(argv[i],argv[i + 1],argv[i + 2],verbose,delete,stderr);
    }

    closeAPI();
    return(0);
}
