/*
 * (c) 2003, Victoria Staubly (vicky@steeds.com), GPL
 */
#include <stdio.h>
#include <errno.h>
#include "proto.h"

int pop3session(char *hostname, char *username, char *password, int verbose, int delete, FILE *errors)
{
    int i, j, s, keep_going, nc, rc;
    short port = 110;
    char buf[2560];
    char *response;

    s = getSocket(hostname,port,verbose,errors);
    if (s <= 0) {
	fprintf(errors,"Unable to open connection to %s\n",hostname);
	return -1;
    }
    response = getLine(buf,sizeof(buf) - 1,s);
    if (verbose)
	printf("Banner: %s",response);

    sprintf(buf,"USER %s\r\n",username);
    putLine(buf,s);
    response = getLine(buf,sizeof(buf) - 1,s);
    if (response[0] != '+') {
	printf("login failed: %s",response);
	closeSocket(s);
	return -1;
    }

    sprintf(buf,"PASS %s\r\n",password);
    putLine(buf,s);
    response = getLine(buf,sizeof(buf) - 1,s);
    if (response[0] != '+') {
	printf("login failed: %s",response);
	closeSocket(s);
	return -1;
    }

    putLine("STAT\r\n",s);
    response = getLine(buf,sizeof(buf) - 1,s);
    if (verbose)
	printf("Status: %s",response);
    if (response[0] == '+') {
	long numMsgs = -1;
	long numBytes = -1;
	sscanf(response,"+OK %ld %ld",&numMsgs,&numBytes);

	if (delete) {
	    int i;
	    printf("Deleting %ld messages in mailbox\n",numMsgs);

	    for (i = 1; i <= numMsgs; i++) {
		if (verbose)
		    printf("deleting msg #%d\n",i);
		sprintf(buf,"DELE %d\r\n",i);
		putLine(buf,s);

		response = getLine(buf,sizeof(buf) - 1,s);
		if (response[0] != '+') {
		    printf("Error deleting msg #%d: %s",i,response);
		    break;
		}
	    }
	} else
	    printf("Found %ld messages in mailbox\n",numMsgs);
    }

    putLine("QUIT\r\n",s);
    response = getLine(buf,sizeof(buf) - 1,s);

    closeSocket(s);
    return(0);
}

void myPerror(FILE *errors, char *errmsg)
{
    fprintf(errors,"%s: %s",errmsg,strerror(errno));
}
