/*
 * (c) 2003, Victoria Staubly (vicky@steeds.com), GPL
 */
#include <stdio.h>
#ifdef WIN32
#include <WinSock.h>
#else
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#endif
#include "proto.h"

int getSocket(char *hostname, short port, int verbose, FILE *errors)
{
    int s = -1;
    struct hostent *h;
    struct sockaddr dest_addr;
    struct sockaddr_in *dest_in;
    
    dest_in = (struct sockaddr_in *)&dest_addr;
    dest_in->sin_family = AF_INET;

    h = gethostbyname(hostname);
    if (h != NULL) {
	if (verbose)
	    printf("%s = %d.%d.%d.%d\n",hostname,
		   (unsigned char)h->h_addr[0],(unsigned char)h->h_addr[1],
		   (unsigned char)h->h_addr[2],(unsigned char)h->h_addr[3]);
	s = socket(AF_INET,SOCK_STREAM,0);
	if (s <= 0) {
	    myPerror(errors,"stream socket");
	    return s;
	}

	dest_in->sin_port = htons(port);
	dest_in->sin_addr.s_addr = *((unsigned long *)(h->h_addr));

	if (connect(s,&dest_addr,sizeof(struct sockaddr_in)) == 0)
	    return s;
	else
	    closeSocket(s);
    }
    return -1;
}

int closeSocket(int s)
{
#ifdef AMIGA
            CloseSocket(s);
#else
#ifdef WIN32
            closesocket(s);
#else
            close(s);
#endif
#endif
}

void putLine(char *str, int sock)
{
    send(sock,str,strlen(str),0);
}

char *getLine(char *buffer, int maxSize, int sock)
{
    int len = 0;
    char *ptr = buffer;
    char lastchar;
    do {
	if (recv(sock,ptr,1,0) < 1)
	    return NULL;
	lastchar = *ptr;
	ptr++;
	len++;
    } while ((len < maxSize) && (lastchar != '\n'));
    *ptr = 0;
    return buffer;
}

int initAPI()
{
#ifdef WIN32
    WORD min_version = MAKEWORD(1,0);
    WSADATA wsaData;

    if (WSAStartup(min_version,&wsaData))
        return(1);
#endif
    return 0;
}

void closeAPI()
{
#ifdef WIN32
    WSACleanup();
#endif
}
